<?php

/*
    Copyright and more information see file info.php
 */


// prevent this file from being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
if (\function_exists('init_fields')) {return true;}
// General Functions (used in multiple files)
// General:            Function to be used later in the code

require str_replace('\\','/',__DIR__).'/presets/layouts.inc';

if (!function_exists('microtime_float')){
    function microtime_float() {
       list($usec, $sec) = explode(" ", microtime());
       return ((float)$usec + (float)$sec);
    }
}

/**
    function: human_file_size

    make human readable filesize (bytes)

*/
if(!function_exists('human_file_size')){
    function human_file_size($bytes, $precision = 2)
    {
        $name = array('Bytes','KB','MB','GB','TB');
        if (!is_numeric($bytes) || $bytes < 0)
            return false;
        for ($level = 0; $bytes >= 1024; $level++)
            $bytes /= 1024;
        return round($bytes, $precision) . ' ' . $name[$level];
    }
}

if(!function_exists('make_dl_dir')){
    function make_dl_dir($sAddonName) {
//       global $sAddonName;
       make_dir(WB_PATH.MEDIA_DIRECTORY.'/'.$sAddonName.'');
       // add .htaccess file to /media/download_gallery folder if not already exist
       if (!file_exists(WB_PATH . MEDIA_DIRECTORY . '/'.$sAddonName.'/.htaccess')
          || (filesize(WB_PATH . MEDIA_DIRECTORY . '/'.$sAddonName.'/.htaccess') !== 140))
       {
          // create a .htaccess file to prevent execution of PHP, HMTL files
          $content = <<< EOT
<Files .htaccess>
  order allow,deny
  deny from all
</Files>

order allow,deny
deny from all
allow from 127.0.0.1
Options -Indexes -ExecCGI
EOT;

          $handle = fopen(WB_PATH . MEDIA_DIRECTORY . '/'.$sAddonName.'/.htaccess', 'w');
          fwrite($handle, $content);
          fclose($handle);
          change_mode(WB_PATH . MEDIA_DIRECTORY . '/'.$sAddonName.'/.htaccess', 'file');
       };
    }
}

/**
    function: dg_change_position

    $direction: up || down
    $id:        file_id || group_id
    $table:        file || group
*/
if(!function_exists('dg_change_position')){
    function dg_change_position( $direction, $id, $table = 'file')
    {

        global $ordering, $page_id, $section_id,$sAddonUrl;
        $baselink = $sAddonUrl.'/move_%s.php?page_id=%d&amp;section_id=%d&amp;';
        if($table == 'file'){
            $link = $baselink.'file_id=%d';
            // work out if we will use move_up or move_down file
            if($ordering == 'ASC')
                $move_direction = ($direction == 'up')     ? 'up' : 'down';
            elseif($ordering == 'DESC')
                $move_direction = ($direction == 'down')? 'up' : 'down';
        }elseif($table == 'group'){
            $link = $baselink.'group_id=%d';
            $move_direction = $direction;
        }else return;
        return(sprintf($link, $move_direction, $page_id, $section_id, $id));
    }
}

if (!\function_exists('load_preg_file_ext')) {
  function load_preg_file_ext ($val,$varname = 'section_id'){
    global $database;
        $retval = array();
        $extFiles = '';
        $table_prefix = TABLE_PREFIX.'mod_download_gallery_';

        $sql  = 'SELECT * FROM `'.$table_prefix.'file_ext` ';
        $sql .= 'WHERE `'.$varname.'` = '.$val;
        /* */
        if(($resExt = $database->query($sql)) && ($resExt->numRows() > 0) ) {

            while (($rows = $resExt->fetchRow(MYSQLI_ASSOC))) {
                $extFiles .= $rows['extensions'].',';
            }
            // $retval  = "~^.+\.(" .str_replace(',','|',$extFiles ). ")$~i";
            $retval  = str_replace(',','|',$extFiles );
        }

        return $retval;

    }
}
/**
    special reorder for stupid group_id '0'
    this function was introduced to handle file positions correctly
*/
if (!function_exists('reorder_id_null_group')){

    function reorder_id_null_group($table, $section_id)
    {
        global $database;
        // Loop through all records and give new order
        $get_all = $database->query(sprintf("SELECT * FROM `%s` WHERE `group_id` = '0' AND `section_id` = '%d' ORDER BY `position` ASC", $table, $section_id));
        if($get_all->numRows() > 0) {
            $i = 0;
            while($row = $get_all->fetchRow(MYSQLI_ASSOC)) {
                $i++;
                // Update each row with new order
                $database->query("UPDATE `".$table."` SET `position` = '$i' WHERE `file_id` = '".$row['file_id']."' AND `group_id` = '0' AND `section_id` = '".$section_id."'");
            }
        } else return true;
    }
}


if (!\function_exists('getDirOptionList')) {
    function getDirOptionList($list=array(), $replace='', $relative = true ){
    global $doc_root,$TEXT,$DGTEXT;

        $print = '';
        if(count($list)==0){return false;}
        $old_group = '';
        $class = ' class="dlg_folder"';
       //     for($x=0; $x < sizeof($list['dir']); $x++  ) {
    //    while (list($key, $link) = each($list['dir'])) {
            foreach ($list['dir'] as $key=>$link) {
            $file = str_replace($doc_root, '', $list['dir'][$key] );
            if( empty($list['dir']) ){continue;}
            $print .= "\t".'<optgroup label="'.basename($key).'"'.$class.' >'."\n";
            $class = ((dirname($key) != $old_group) ? ' class="dlg_folder"' : ' class="dlg_subfolder"');

            if( sizeof($list['filename'][$key]) == 0 ){
                $file = str_replace($doc_root, '', $key );
                $print .= "\t\t".'<option value="'.str_replace($replace,'',$file).'">'.$DGTEXT['EMPTY_FOLDER'].'</option>'."\n";
                // $old_group = ($key != $old_group) ? $key : $old_group;
                $print .= "\t".'</optgroup>'."\n";
                continue;
            }

            for($y=0; $y < sizeof($list['filename'][$key]); $y++  ) {
                $file = str_replace($doc_root, '', $list['filename'][$key][$y] );
                $filename = basename($file);
                $print .= "\t\t".'<option value="'.str_replace($replace,'',$file).'">'.$filename.'</option>'."\n";
            }
            $old_group = dirname($key);
            $print .= "\t".'</optgroup>'."\n";
        }
        return $print;
    }
}
    /**
     *
     * @param string $baseDir
     * @param string|array $allowedExtensions 'jpg|gif' or array('jpg','gif') or '*' for all
     * @param string $default path/filename from selected file
     * @param bool $grouped
     * @param string $groupClass
     */
if (!\function_exists('getRecursiveFileOptionList')) {
    function getRecursiveFileOptionList( $baseDir, $allowedExtensions, $default = '', $grouped = true, $groupClass = 'dlg_folder')
    {
        if(is_array($allowedExtensions)) {
            $regPattern = implode('|', $allowedExtensions);
        }else {
            if($allowedExtensions == '*' or $allowedExtensions == '') {
                $regPattern = '.*';
            }else {
                $regPattern = $allowedExtensions;
            }
        }
        $regPattern = '~^.+\.('.$regPattern.')$~i';
print '<pre  class="mod-pre" style="margin-left:30px;">function <span>'.__FUNCTION__.'( '.''.' );</span>  filename: <span>'.basename(__FILE__).'</span>  line: '.__LINE__.' -> '."\n";
print_r( $default ); print '</pre>'; \flush (); //  sleep(10); die();

        $class = ($groupClass != '') ? 'class="'.$groupClass.'"' : '';
        $directory = rtrim(str_replace('\\', '/', realpath($baseDir)), '/');
        $tmpVal = [];
        $dirIter = new RecursiveDirectoryIterator($directory,  RecursiveDirectoryIterator::SKIP_DOTS);
        // Skip "dot" files
//         $dirIter->setFlags(RecursiveDirectoryIterator::SKIP_DOTS);

        $recursiveIterator = new RecursiveIteratorIterator($dirIter,
                                RecursiveIteratorIterator::SELF_FIRST,
                                RecursiveIteratorIterator::CATCH_GET_CHILD
                            );
        $regexIterator = new RegexIterator($recursiveIterator, $regPattern, RegexIterator::GET_MATCH);
        foreach($regexIterator as $key => $value) {
            $pathFile = str_replace(dirname($directory),'',str_replace('\\', '/', $key));
            $tmpVal[] = str_pad(dirname($pathFile), 256, '$').'/'.basename($pathFile);
        }
        natcasesort($tmpVal);
        $retVal = $lastItem = '';
//        while (list( ,$filePath) = each($tmpVal)) {
        foreach ($tmpVal as $filePath) {
            $dir  = trim(dirname($filePath),'$');
            $file = trim(basename($filePath), '$');
            if(    $dir != $lastItem && $lastItem != '' && $grouped) {
                $retVal .= "\t".'</optgroup>'.PHP_EOL;
            }
            if(    $dir != $lastItem && $grouped) {
                $retVal .= "\t".'<optgroup label="'.$dir.'" '.$class.'>'.PHP_EOL;
            }
            $selected = '';
            if (strcasecmp($default, $dir.'/'.$file) == 0){
            $selected = (strcasecmp($default, $dir.'/'.$file) == 0) ? ' selected="selected"' : '';
            }
            $retVal .= "\t\t".'<option value="'.$dir.'/'.$file.'"'.$selected.'>'.$file.'</option>'.PHP_EOL;
            $lastItem = $dir;
        }
        $retVal .= $grouped ? ("\t".'</optgroup>'.PHP_EOL) : '';
        return $retVal;
    }
}

if (!\function_exists('_file_list')) {
// Function to open a directory and add to a file list
    function _file_list($directory, $search = '/.*/', $show_hidden = false)
    {
        $result_list = array();
        if (is_dir($directory))
        {
            $dir = dir($directory); // Open the directory
            while (false !== ($entry = $dir->read())) {
                // Skip hidden files
                // remove if( sizeof($skip) > 0 && in_array($entry, $skip) ) { continue; } // Check if we to skip anything else
                if($entry[0] == '.' && $show_hidden == false) { continue; }
                // Skip pointers
                if(preg_match("!(\.|\..)$!", $entry)) { continue; }
                // Check if we to skip anything else
                if( !preg_match($search, $entry)  ) { continue; }
                // Add files to list
                if(is_file( $directory.'/'.$entry) ) {
                    $result_list[] = $directory.'/'.$entry;
                }
            }
            $dir->close(); // Now close the folder object
        }
        // make the list nice. Not all OS do this itself
       if(natcasesort($result_list))
       {
            $result_list = array_merge($result_list);
       }

        return $result_list;
    }
}
if (!\function_exists('getDirectory')) {
    function getDirectory( $root = '', $search = '/.*/' ){
    global $doc_root,$list;
       //     $search = (empty($search)) ? '/.*/' : $search;
        $dir = basename(dirname($root));
        $root = empty ($root) ? getcwd() : $root;
        if (($handle = opendir($root)))    {
            while(($file = @readdir($handle)) !== false) {
                if(!preg_match("!(\.|\..)$!", $file)){
                    if(is_dir($root.'/'.$file)) {
                        $dir = str_replace($doc_root, '', $root.'/'.$file );
                        getDirectory( $root.'/'.$file, $search );
                    } elseif(is_file($root.'/'.$file)) {
                        // $list[$dir][] = $root.'/'.$file;
                    }
                } elseif (!preg_match($search, $file) ) {
                    continue;
                // } elseif(preg_match("!(\..)$!", $file)){
                } else {
                    $file = (dirname($root.'/'.$file));
                    $parent = basename(dirname($file));
                    $key = $parent.'/'.basename($file);
                    $list['dir'][$key] = $file;
                }
            }
            @closedir($dp);
        }

        while (list($key, $link) = each($list['dir'])) {
            $list['filename'][$key] = _file_list($link,$search);
        }

        return $list;
    }
}

if (!\function_exists('encodeVar')) {
    function encodeVar($mValue) {
        $sRetval = strtoupper(strrev(dechex(intval($mValue)*9340000)));
        return $sRetval;
    }
}
if (!\function_exists('decodeVar')) {
    function decodeVar($mValue) {
        $sRetval = intval(hexdec(strrev($mValue))/9340000);
        return $sRetval;
    }
}
