<?php
/**
 * @category        WebsiteBaker
 * @package         WebsiteBaker_core
 * @author          Ryan Djurovich, WebsiteBaker Project, Werner v.d.Decken
 * @copyright       2009-2018, WebsiteBaker Org. e.V.
 * @link            http://websitebaker.org
 * @license         http://www.gnu.org/licenses/gpl.html
 * @version         $Id: class.order.php 22 2018-09-09 15:17:39Z Luisehahne $
 * @filesource      /framework/class.order.php
 * Ordering class
 * This class will be used to change the order of an item in a table
 * which contains a special order field (type must be integer)
 */
/*******************************************************************************
 * abstract factory for application
 */
namespace addon\download_gallery\helpers;
/* -------------------------------------------------------- */
// Must include code to prevent this file from being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */

class ReOrder extends \order {


    /**
     * Constructor
     * @param string $Table
     * @param string $FieldOrder
     * @param string $FieldId
     * @param string $FieldGroup
     * use $GLOBALS['database']
     */
    public function __construct($Table, $FieldOrder, $FieldId, $FieldGroup) {
            parent::__construct($Table, $FieldOrder, $FieldId, $FieldGroup);
    }


    /**
     * Renumbering a group from 1 to n (should be called if a row in the middle has been deleted)
     * @param string|int $mGroup
     * @param string     $sOrder
     *        possible values ASC|DESC
     * @return bool
     *
     */
    public function reOrder($mGroup, $sOrder='ASC') {
        $sType = \gettype($mGroup);
        $sWHERE = '';
            if ($sType == 'string') {$sWHERE = sprintf('WHERE `%s` = \'$this->_DB->escapeString(%s)\' ',$this->_FieldGroup,$mGroup);}
        elseif ($sType == 'integer') {$sWHERE = sprintf('WHERE `%s` = %d ',$this->_FieldGroup,$mGroup);}
        else {$sWHERE = sprintf('WHERE `%s` = \'$this->_DB->escapeString(%s)\' ',$this->_FieldGroup,$mGroup);}
    //  prepare ordering
        $sSort = (in_array($sOrder,['ASC','DESC']) ? $sOrder : 'ASC');
    //  Loop through all records and give new order
        $sqlSet = 'SET @c:=0;'."\n";
        $this->_DB->query($sqlSet);
        $sqlSet = 'UPDATE `'.$this->_Table.'` SET `'.$this->_FieldOrder.'` = (SELECT @c:=@c+1) '."\n"
//                . 'WHERE `'.$this->_FieldGroup.'` = \''.$mGroup.'\' '."\n"
                .$sWHERE."\n"
                . 'ORDER BY `'.$this->_FieldId.'` '.$sSort.';'."\n";
        return $this->_DB->query($sqlSet);
    }

} // end of class
