<?php
/*
 * CMS module: Download Gallery 2
 * Copyright and more information see file info.php
*/
declare(strict_types=1);

use bin\{WbAdaptor,SecureTokens,Sanitize,requester};
use bin\helpers\{PreCheck,msgQueue};

// prevent this file from being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}

    $sAddonFile   = \str_replace('\\','/',__FILE__);
    $sAddonPath   = (\dirname($sAddonFile)).'/';
    $sModulesPath = \dirname($sAddonPath).'/';
    $sModuleName  = basename($sModulesPath);
    $sAddonName   = basename($sAddonPath);
    $ModuleRel    = ''.$sModuleName.'/';
    $sAddonRel    = ''.$sModuleName.'/'.$sAddonName.'/';
    $sPattern     = "/^(.*?\/)".$sModuleName."\/.*$/";
    $sAppPath     = preg_replace ($sPattern, "$1", $sModulesPath, 1 );

    $database->query("DROP TABLE IF EXISTS `".TABLE_PREFIX."mod_download_gallery_files`");
    $mod_dl_gallery = 'CREATE TABLE `'.TABLE_PREFIX.'mod_download_gallery_files` ( '
                 . '`file_id` INT NOT NULL AUTO_INCREMENT, '
                 . '`section_id` INT NOT NULL DEFAULT \'0\', '
                 . '`page_id` INT NOT NULL DEFAULT \'0\',    '
                 . '`group_id` INT NOT NULL DEFAULT \'0\','
                 . '`active` INT NOT NULL DEFAULT \'0\', '
                 . '`position` INT NOT NULL DEFAULT \'0\', '
                 . '`title` VARCHAR(255) NOT NULL DEFAULT \'\' , '
                 . '`link` TEXT NOT NULL , '
                 . '`filename` VARCHAR(250) NOT NULL DEFAULT \'\' , '
                 . '`extension` VARCHAR(250) NOT NULL DEFAULT \'\' , '
                 . '`description` TEXT CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL , '
                 . '`modified_when` INT NOT NULL DEFAULT \'0\', '
                 . '`modified_by` INT NOT NULL DEFAULT \'0\', '
                 . '`dlcount` INT NOT NULL DEFAULT \'0\', '
                 . '`size` INT NOT NULL DEFAULT 0, '
                 . '`released` INT NOT NULL DEFAULT 0, '
                 . 'PRIMARY KEY (file_id)'
                 . ' )';
    $database->query($mod_dl_gallery);

    $database->query("DROP TABLE IF EXISTS `".TABLE_PREFIX."mod_download_gallery_settings`");
    $mod_dl_gallery = 'CREATE TABLE `'.TABLE_PREFIX.'mod_download_gallery_settings` ( '
                 . '`section_id` INT NOT NULL DEFAULT \'0\','
                 . '`page_id` INT NOT NULL DEFAULT \'0\','
                 . '`header` TEXT NOT NULL ,'
                 . '`files_loop` TEXT NOT NULL ,'
                 . '`footer` TEXT NOT NULL ,'
                 . '`files_per_page` INT NOT NULL DEFAULT \'0\','
                 . '`file_size_roundup` INT NOT NULL DEFAULT \'0\','
                 . '`file_size_decimals` INT NOT NULL DEFAULT \'0\','
                 . '`file_header` TEXT NOT NULL ,'
                 . '`file_footer` TEXT NOT NULL ,'
                 . '`ordering` TINYINT(3) NOT NULL DEFAULT \'0\','
                 . '`extordering` TINYINT(3) NOT NULL DEFAULT \'0\','
                 . '`userupload` TINYINT(3) NOT NULL DEFAULT \'0\','
                 . '`gheader` TEXT NOT NULL ,'
                 . '`gloop` TEXT NOT NULL ,'
                 . '`gfooter` TEXT NOT NULL ,'
                 . '`search_filter` TEXT NOT NULL ,'
                 . '`search_layout` TEXT NOT NULL ,'
                 . '`pushmode` TINYINT( 3 ) NOT NULL DEFAULT 0,'
                 . '`use_captcha` TINYINT( 3 ) NOT NULL DEFAULT 0, '
                 . 'PRIMARY KEY (section_id)'
                 . ' )';
    $database->query($mod_dl_gallery);

    $database->query("DROP TABLE IF EXISTS `".TABLE_PREFIX."mod_download_gallery_groups`");
    $mod_dlg = 'CREATE TABLE `'.TABLE_PREFIX.'mod_download_gallery_groups` ( '
                 . '`group_id` INT NOT NULL AUTO_INCREMENT,'
                 . '`section_id` INT NOT NULL DEFAULT \'0\','
                 . '`page_id` INT NOT NULL DEFAULT \'0\','
                 . '`position` INT NOT NULL DEFAULT \'0\','
                 . '`active` INT NOT NULL DEFAULT \'0\','
                 . '`title` VARCHAR(255) NOT NULL DEFAULT \'\', '
                 . '`description` TEXT CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,'
                 . 'PRIMARY KEY (group_id)'
                 . ' )';
    $database->query($mod_dlg);

    $database->query("DROP TABLE IF EXISTS `".TABLE_PREFIX."mod_download_gallery_file_ext`");
    $mod_dl_gallery = 'CREATE TABLE `' . TABLE_PREFIX . 'mod_download_gallery_file_ext` ( '
                 . '`fileext_id` INT NOT NULL AUTO_INCREMENT, '
                 . '`section_id` INT NOT NULL DEFAULT \'0\', '
                 . '`page_id` INT NOT NULL DEFAULT \'0\', '
                 . '`file_type` VARCHAR(250) NOT NULL DEFAULT \'\' , '
                 . '`file_image` VARCHAR(250) NOT NULL DEFAULT \'\' , '
                 . '`extensions` TEXT NOT NULL, '
                 . 'PRIMARY KEY (fileext_id)'
                 . ' )';
    $database->query($mod_dl_gallery);

// Insert blank row (there needs to be at least on row for the search to work)
    //$database->query("INSERT INTO ".TABLE_PREFIX."mod_download_gallery_files (section_id,page_id) VALUES ('0', '0')");
    //$database->query("INSERT INTO ".TABLE_PREFIX."mod_download_gallery_settings (section_id,page_id) VALUES ('0', '0')");
    //$database->query("INSERT INTO ".TABLE_PREFIX."mod_download_gallery_groups (section_id,page_id) VALUES ('0', '0')");

//Add folder for the files
    if (!\function_exists('init_fields')) {require ($sAddonPath.'/functions.php');}
    make_dl_dir($sAddonName);

