<?php
/*
 * Copyright and more information see file info.php
 */
 /*
        changes by Stefek:
        - added "reorder file position by group"
                This is needed to ensure that files of every group
                got their own ordering
        - apply special id null reorder function
                (there is no such methode in the 'order' class
 */
if (!\defined('SYSTEM_RUN')) {require(((\dirname((__DIR__),2))).'/config.php');}

    $sAddonName = basename(__DIR__);
    $sAddonRel  = str_replace(WB_PATH,'',__DIR__);
    $sAddonUrl  = WB_URL.str_replace(['\\'],['/'],$sAddonRel);
    $sAddonPath = str_replace(['\\'],['/'],WB_PATH.'/'.$sAddonRel);
    $unixtime   = 0;
    $filesize   = 0;
    $sErrorMsg  = '';

    $update_when_modified = true; // Tells script to update when this page was last updated
    require(WB_PATH.'/modules/admin.php'); // Include WB admin wrapper script
    $sBacklink = ADMIN_URL.'/pages/modify.php?page_id='.$page_id;

    if (!\function_exists('init_fields')) {require ($sAddonPath.'/functions.php');}

// Get id
    $id = '';
    $file_id = '';
    if (!isset($_POST['file_id']) || !is_numeric($_POST['file_id'])
    ||  !isset($_POST['active']) || !is_numeric($_POST['active'])) {
            header("Location: ".$sBacklink);
    } else {
            $id = (int) $_POST['file_id'];
            $file_id = $id;
            $active = $admin->get_post('active');
    }

// STEP 0:        initialize some variables
    $filename = '';
    $fname = '';
    $fileext = '';

// Validate all fields
    if($admin->get_post('title') == '' && $admin->get_post('url') === '') {
        $admin->print_error($MESSAGE['GENERIC_FILL_IN_ALL'], $sAddonUrl.'/modify_file.php?page_id='.$page_id.'&section_id='.$section_id.'&file_id='.$id);
    } else {
        $title = $admin->StripCodeFromText(htmlspecialchars($admin->get_post('title')));
        $description = $admin->StripCodeFromText($admin->get_post('description'));
        $old_link = $admin->StripCodeFromText($admin->get_post('link'));
        $existingfile = ($admin->get_post('existingfile'));
        $group = ($admin->get_post('group'));
        $overwrite = ($admin->get_post('overwrite'));
        $remotelink = $admin->StripCodeFromText($admin->get_post('remote_link'));
        if (($existingfile==="") && ($remotelink=="")){ $existingfile=$old_link;}
        $description = $admin->ReplaceAbsoluteMediaUrl($description);
    }

    $aTmp = parse_url($old_link);
    $old_link = (isset($aTmp['path']) ? $aTmp['path'] : MEDIA_DIRECTORY.'/'.basename(__DIR__).'/'.basename($old_link));
    if (empty($existingfile) && (empty($remotelink))) {$existingfile=$old_link;}

// Get page link URL
    $query_page = $database->query("SELECT `level`, `link` FROM `".TABLE_PREFIX."pages` WHERE `page_id` = '$page_id'");
    $page = $query_page->fetchAssoc();
    $page_level = $page['level'];
    $page_link = $page['link'];

// Check if the user uploaded an file or wants to delete one
    if ((isset($_FILES['file']['tmp_name'])) && ($_FILES['file']['tmp_name'] !== '') && (empty($existingfile))) {
        // Get real filename and set new filename
        $filename = trim($_FILES['file']['name']);
        $path_parts = pathinfo($filename);
        $fileext = strtolower(($path_parts['extension'] ?? ''));
        $new_filename = WB_PATH.MEDIA_DIRECTORY.'/'.$sAddonName.'/'.$filename;

        // Work-out what the link should be
        $file_link = '/'.$sAddonName.'/'.$filename;
        if ($overwrite=="yes" or !file_exists(WB_PATH.MEDIA_DIRECTORY.'/'.$sAddonName.'/' .$filename)) {
            // Upload file
            move_uploaded_file($_FILES['file']['tmp_name'], $new_filename);
            change_mode($new_filename);
        }

        // update file information in the database
        $sSqlFiles = 'UPDATE `'.TABLE_PREFIX.'mod_download_gallery_files` SET '
                   .'`extension` = \''.$database->escapeString($fileext).'\', '
                   .'`filename` = \''.$database->escapeString($filename).'\' '
                   .'WHERE `file_id` = '.(int)$file_id.''
                   .'  AND `page_id` = '.(int)$page_id.'';
        $database->query($sSqlFiles);
    }

// Check if the user uploaded a remote link
    if ((isset($_POST['remote_link'])) && ($_POST['remote_link'] != '') && (empty($filename)))
    {
        // Get real filename and set new filename
        $filename = trim($remotelink);
        $path_parts = pathinfo($filename);
        $fileext = strtolower(($path_parts['extension'] ?? ''));
        $new_filename = $filename;

        // Work-out what the link should be
        $file_link = $filename;

        // update file information in the database
        $sSqlFiles = 'UPDATE `'.TABLE_PREFIX.'mod_download_gallery_files` SET '
                   .'`extension` = \''.$database->escapeString($fileext).'\','
                   .'`filename` = \''.$database->escapeString($filename).'\','
                   .'`link`=\''.$database->escapeString($file_link).'\' '
                   .'WHERE `file_id` = '.(int)$file_id.''
                   .'  AND `page_id` = '.(int)$page_id.'';
        $database->query($sSqlFiles);
    }

    if ((isset($_POST['delete_file']) && $_POST['delete_file'] !== '') ||( isset($_POST['delete_file2']) && $_POST['delete_file2'] !== ''))
    {
        // query the database for the file extension
        $query_content = $database->query("SELECT * FROM `".TABLE_PREFIX."mod_download_gallery_files` WHERE `file_id` = '$file_id' AND `page_id` = '$page_id'");
        $fetch_content = $query_content->fetchAssoc();
        $fname = $fetch_content['filename'];
        $ext = $fetch_content['extension'];
        // Try unlinking file
        $query_duplicates = $database->query("SELECT * FROM `".TABLE_PREFIX."mod_download_gallery_files` WHERE `filename` = '$fname' AND `extension` ='$ext' AND `page_id` = '$page_id'");
        $dups=$query_duplicates->numRows();
        //only delete the file if there is 1 database entry (not used on multiple sections)
        if (($dups==1)and (isset($_POST['delete_file']))) {
            $file = WB_PATH.MEDIA_DIRECTORY.'/'.$sAddonName.'/' . $fname;
            if (is_writable($file)) {
                unlink($file);
            }
        }
        //set variables so the fields are cleared so new file can be placed
        $file_link="";
        $filename="";
        $active=0;
    }
    if (trim($existingfile!=='')) {
        $file_link = $existingfile;
        $path_parts = pathinfo($file_link);
        $fileext = strtolower($path_parts['extension']);

        if  (empty($remotelink)) {
            $filename = strtolower($path_parts['basename']);
        }
        //if file is to be deleted need to clear the record filename so a new file can be put into place with the existing title,description
        if ((isset($_POST['delete_file']) && $_POST['delete_file'] != '') || (isset($_POST['delete_file2']) && $_POST['delete_file2'] != '')) {
            $filename="";
            $file_link="";
            $fileext="";
            $sBacklink = $sAddonUrl.'/modify_file.php?page_id='.$page_id.'&section_id='.$section_id.'&file_id='.$file_id;
        }
        if (isset($_POST['save'])) {
            $sBacklink = $sAddonUrl.'/modify_file.php?page_id='.$page_id.'&section_id='.$section_id.'&file_id='.$file_id;
        }

        $sSqlFiles = 'UPDATE `'.TABLE_PREFIX.'mod_download_gallery_files` SET '
                   .'`extension` = \''.$database->escapeString($fileext).'\','
                   .'`filename` = \''.$database->escapeString($filename).'\','
                   .'`link`=\''.$database->escapeString($file_link).'\' '
                   .'WHERE `file_id` = '.(int)$file_id.''
                   .'  AND `page_id` = '.(int)$page_id.'';
        $database->query($sSqlFiles);
    }// existingfile

    $aTmp = parse_url($file_link);
    $aTmp['scheme'] = ($aTmp['scheme'] ?? '');
    if ($aTmp['scheme']){

    } else {
        $file_link = (isset($aTmp['path']) ? str_replace(MEDIA_DIRECTORY,'',$aTmp['path']) :'/'.basename(__DIR__).'/'.basename($file_link));
    }
    $released = time();

    $filelink = (strpos($file_link, '://')===0) ? $file_link : str_replace(MEDIA_DIRECTORY,'',$file_link);

    if (file_exists(WB_PATH.MEDIA_DIRECTORY.$filelink)) {
            $unixtime = filemtime(WB_PATH.MEDIA_DIRECTORY.$filelink);
            $filesize = filesize(WB_PATH.MEDIA_DIRECTORY.$filelink);
    }

// Update row after insert, will be replaced later by INSERT INTO
    $sSqlInsertFiles = 'UPDATE `'.TABLE_PREFIX.'mod_download_gallery_files` SET '
    . '`title` = \''.$database->escapeString($title).'\', '
    . '`link` = \''.$database->escapeString($file_link).'\', '
    . '`group_id` = '.(int)$group.', '
    . '`description` = \''.$database->escapeString($description).'\', '
    . '`active` = '.$active.', '
    . '`modified_when` = '.time().','
    . '`modified_by` = '.(int)$admin->getUserId().', '
    . '`released` = '.(int)$unixtime.', '
    . '`size` = '.(int)$filesize.' '
    . 'WHERE `file_id` = '.(int)$file_id.' '
    .'   AND `page_id` = '.(int)$page_id;

    if (!$database->query($sSqlInsertFiles)){
        $sErrorMsg = \nl2br(\sprintf("---- [%04d] %s \n %s \n",__LINE__,$database->get_error(),''));

    }

/**
        REORDER
*/

    if ($group===0){
        // apply special id null reorder handling (load extern functions)
        if (!function_exists('reorder_id_null_group')){require('functions.php');}
        reorder_id_null_group(TABLE_PREFIX."mod_download_gallery_files", $section_id);
    } else {
        // Include the ordering class
    //        if (!class_exists('order')){require(WB_PATH.'/framework/class.order.php');}
    //  Initialize order object
        $order = new \addon\download_gallery\helpers\ReOrder(TABLE_PREFIX."mod_download_gallery_files", 'position', 'file_id', 'group_id');
    //  reorder all groups in this group_id

        $order->reOrder((int)$group);
    }

// Check if there is a db error, otherwise say successful
    if ($database->is_error() || !empty($sErrorMsg)) {
        if (!empty($sErrorMsg)){
            $admin->print_error(sprintf('[%d] %s',__LINE__,($sErrorMsg)), $sAddonUrl.'/modify_file.php?page_id='.$page_id.'&section_id='.$section_id.'&file_id='.$id);
        } else {
            $admin->print_error(sprintf('[%d] %s',__LINE__,($database->get_error())), $sAddonUrl.'/modify_file.php?page_id='.$page_id.'&section_id='.$section_id.'&file_id='.$id);
        }
    } else {
        if((isset($_POST['delete_file']) && $_POST['delete_file'] != '') || (isset($_POST['delete_file2']) && $_POST['delete_file2'] != '')) {
            $admin->print_success($TEXT['SUCCESS'], $sBacklink);
        } else {
            $admin->print_success($TEXT['SUCCESS'], $sBacklink);
        }
    }

// Print admin footer
    $admin->print_footer();

