<?php
/*
 * Copyright and more information see file info.php
 */

if (!\defined('SYSTEM_RUN')) {require((\dirname(\dirname((__DIR__)))).'/config.php');}

// Include WB admin wrapper script
$update_when_modified = true; // Tells script to update when this page was last updated
require(WB_PATH.'/modules/admin.php');

    $sAddonName = basename(__DIR__);
    $sAddonRel  = str_replace(WB_PATH,'',__DIR__);
    $sAddonUrl  = WB_URL.str_replace(['\\'],['/'],$sAddonRel);
    $sAddonPath = str_replace(['\\'],['/'],WB_PATH.'/'.$sAddonRel);

// Include addon functions file
if (!\function_exists('init_fields')) {require ($sAddonPath.'/functions.php');}

    $sBacklink = ADMIN_URL.'/pages/modify.php?page_id='.$page_id;

// This code removes any php tags and adds slashes
    $friendly = array('&lt;', '&gt;', '?php');
    $raw = array('<', '>', '');

// STEP 1: Retrieve settings from POST vars
    if (isset($_POST['file_size_decimals']) && is_numeric($_POST['file_size_decimals'])) {
        $file_size_decimals = (int)$_POST['file_size_decimals'];
    } else {
        $file_size_decimals = '0';
    }
    if (isset($_POST['files_per_page']) && is_numeric($_POST['files_per_page'])) {
        $files_per_page = (int)$_POST['files_per_page'];
    } else {
        $files_per_page = '0';
    }
    if (isset($_POST['file_size_round']) && is_numeric($_POST['file_size_round'])) {
        $file_size_roundup = (int)$_POST['file_size_round'];
    } else {
        $file_size_roundup = '0';
    }
    if (isset($_POST['search_filter']) && is_numeric($_POST['search_filter'])) {
        $search_filter = (int)$_POST['search_filter'];
    } else {
        $search_filter = '0';
    }
    if (isset($_POST['ordering']) && is_numeric($_POST['ordering'])) {
        $ordering = (int)$_POST['ordering'];
    } else {
        $ordering = -1;
    }
    if (isset($_POST['extordering']) && is_numeric($_POST['extordering'])) {
        $extordering = (int)$_POST['extordering'];
    } else {
        $extordering = 2;
    }
    if (isset($_POST['pushmode']) && ($_POST['pushmode'] == 1)) {
        $pushmode = 1;
    } else {
        $pushmode = 0;
    }
    if (isset($_POST['userupload']) && is_numeric($_POST['userupload'])) {
        $userupload = (int)$_POST['userupload'];
    } else {
        $userupload = 0;
    }
    if (isset($_POST['reset_table']) && is_numeric($_POST['reset_table'])) {
        $reset_table = (int)$_POST['reset_table'];
    } else {
        $reset_table = 0;
    }
    if (isset($_POST['use_captcha']) && is_numeric($_POST['use_captcha'])) {
        $use_captcha = (int)$_POST['use_captcha'];
    } else {
        $use_captcha = 0;
    }
    $sFileOrdering = (($ordering >= 16) || $ordering == -1) ? 'DESC' : 'ASC';
    switch ($ordering):
        case 0:
        case 16:
            $orderby = 'title';
            break;
        case 1:
        case 32:
            $orderby = 'released';
            break;
        case 2:
        case 64:
            $orderby = 'modified_when';
            break;
        case 4:
        case 128:
            $orderby = 'size';
            break;
        case 8:
        case 256:
            $orderby = 'position';
            break;
        default:
            $orderby = 'released';
    endswitch;
//    $files   = new \addon\download_gallery\helpers\ReOrder(TABLE_PREFIX.'mod_download_gallery_files', 'position', $orderby, 'section_id');
//    $files->reOrder($section_id,$sFileOrdering);

    $sExtOrdering  = (($extordering >= 4) || $extordering == -1) ? 'DESC' : 'ASC';
    switch ($extordering):
        case '0':
        case '4':
            $sExtOrderby   = "title";
            break;
        case '1':
        case '8':
            $sExtOrderby   = "group_id";
            break;
        case '2':
        case '16':
        default:
            $sExtOrderby   = "position";
    endswitch;
//    $groups = new \addon\download_gallery\helpers\ReOrder(TABLE_PREFIX.'mod_download_gallery_groups', 'position', $sExtOrderby, 'section_id');
//    $groups->reOrder($section_id,$sExtOrdering);

    if (isset($_POST['save-layout']) || isset($_POST['save-layout-overview'])) {
        $header        = $admin->StripCodeFromText(str_replace($friendly, $raw, $_POST['header']));
        $footer        = $admin->StripCodeFromText(str_replace($friendly, $raw, $_POST['footer']));
        $files_loop    = $admin->StripCodeFromText(str_replace($friendly, $raw, $_POST['files_loop']));
        $file_header   = $admin->StripCodeFromText(str_replace($friendly, $raw, $_POST['file_header']));
        $file_footer   = $admin->StripCodeFromText(str_replace($friendly, $raw, $_POST['file_footer']));
        $gheader       = $admin->StripCodeFromText(str_replace($friendly, $raw, $_POST['gheader']));
        $gloop         = $admin->StripCodeFromText(str_replace($friendly, $raw, $_POST['gloop']));
        $gfooter       = $admin->StripCodeFromText(str_replace($friendly, $raw, $_POST['gfooter']));
        $search_layout = $admin->StripCodeFromText(str_replace($friendly, $raw, $_POST['search_layout']));
    } elseif (isset($_POST['reset_table']) && $reset_table > 0){
        $header        = '';
        $footer        = '';
        $file_header   = '';
        $files_loop    = '';
        $file_footer   = '';
        $gloop         = '';
        $search_layout = '';
        $gheader       = '';
        $gfooter       = '';
        $iGetLayout = $reset_table;
        init_fields($header, $footer, $file_header, $files_loop, $file_footer, $gloop, $search_layout, $gheader, $gfooter);
        $sBacklink = $sAddonUrl.'/modify_settings.php?page_id='.$page_id.'&section_id='.$section_id;
    }
    if (isset($_POST['save-settings']) || isset($_POST['save-layout'])) {
        $sBacklink = $sAddonUrl.'/modify_settings.php?page_id='.$page_id.'&section_id='.$section_id;
    }


    if (isset($_POST['layout_settings'])) {
        $sSqlLayout = '
        UPDATE `'.TABLE_PREFIX.'mod_download_gallery_settings` SET
        `header` = \''.$database->escapeString($header).'\'
        ,`footer` = \''.$database->escapeString($footer).'\'
        ,`file_header` = \''.$database->escapeString($file_header).'\'
        ,`file_footer` = \''.$database->escapeString($file_footer).'\'
        ,`files_loop` = \''.$database->escapeString($files_loop).'\'
        ,`gloop` = \''.$database->escapeString($gloop).'\'
        ,`gfooter` = \''.$database->escapeString($gfooter).'\'
        ,`gheader` = \''.$database->escapeString($gheader).'\'
        ,`search_layout` = \''.$database->escapeString($search_layout).'\'
        WHERE `section_id` = '.(int)$section_id.'
        ';
        $sSql = $sSqlLayout;
    } else if (isset($_POST['modify_settings'])){
        $sSqlSettings = '
        UPDATE `'.TABLE_PREFIX.'mod_download_gallery_settings` SET
        `files_per_page` = '.(int)$files_per_page.'
        ,`search_filter` = '.$search_filter.'
        ,`file_size_roundup` = '.(int)$file_size_roundup.'
        ,`file_size_decimals` = '.(int)$file_size_decimals.'
        ,`ordering` = '.(int)$ordering.'
        ,`extordering` = '.(int)$extordering.'
        ,`userupload` = '.(int)$userupload.'
        ,`use_captcha` = '.(int)$use_captcha.'
        ,`pushmode` = '.(int)$pushmode.'
        WHERE `section_id` = '.(int)$section_id.'
        ';
        $sSql = $sSqlSettings;
    }
        $database->query($sSql);

// Check if there is a db error, otherwise say successful
    if($database->is_error()) {
        $admin->print_error($database->get_error(),$sBacklink);
    } else {
        $admin->print_success($TEXT['SUCCESS'], $sBacklink);
    }

// Print admin footer
$admin->print_footer();
