<?php
/**
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Description of Lingual
 *
 * @package      Addon package
 * @copyright    Dietmar Wöllbrink <dietmar.woellbrink@websitebaker.org>
 * @author       Dietmar Wöllbrink <dietmar.woellbrink@websitebaker.org>
 * @author       Manuela v.d.Decken <manuela@isteam.de>
 * @license      GNU General Public License 2.0
 * @version      1.0.0-dev.0
 * @revision     $Id:  $
 * @since        File available since 02.12.2017
 * @deprecated   no
 * @description  xxx
 *
 */
declare(strict_types = 1);
//declare(encoding = 'UTF-8');


use bin\{WbAdaptor,wb,SecureTokens,Sanitize};
use bin\helpers\{PreCheck,msgQueue};

// prevent this file from being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}

//    $sAddonRel  = str_replace(WB_PATH,'',__DIR__);
//    $sAddonUrl  = WB_URL.str_replace(['\\'],['/'],$sAddonRel);
    $oReg = WbAdaptor::getInstance();
    $oRequest = $oReg->getRequester();
    $sAddonName = \basename(__DIR__);
    $sAddonObject = 'dlg';
    $sAddonRel  = '/modules/'.$sAddonName;
    $sAddonUrl  = WB_URL.$sAddonRel;
    $sAddonPath = \str_replace(['\\'],['/'],WB_PATH.'/'.$sAddonRel);
    $MediaRel   = MEDIA_DIRECTORY;
    $sAddonTemplateRel = '/'.$sAddonRel.'/templates';

/* -------------------------------------------------------- */
    $bLocalDebug  = (\is_readable($sAddonPath.'.setDebug'));
    $bSecureToken = (!\is_readable($sAddonPath.'.setToken'));
    //$bFrontendCss = (!\is_readable($sAddonPath.'.setFrontend'));
    $sPHP_EOL     = ($bLocalDebug ? "\n" : '');
    $sqlEOL       = ($bLocalDebug ? "\n" : "");
/* ------------------------------------------------------------------ */
// settings needs a admin object
    $oReg     = WbAdaptor::getInstance();
    $oDb      = $oReg->getDatabase();
    $oTrans   = $oReg->getTranslate();
    $oRequest = $oReg->getRequester();
    $oApp     = $oReg->getApplication();
    $isAuth   = $oApp->is_authenticated();
/* ------------------------------------------------------------------ */
    $aRequestVars = [];
    $aVars = $oReg->Request->getParamNames();
    foreach ($aVars as $sName) {
        $aRequestVars[$sName] = $oReg->Request->getParam($sName);
    }

    $sDateFormat = ($oReg->DateFormat ?? 'system_default');
    $sDateFormat = (($sDateFormat === 'system_default') ? $oReg->DefaultDateFormat : $oReg->DateFormat);

    $sTimeFormat = ($oReg->TimeFormat ?? 'system_default');
    $sTimeFormat = (($sTimeFormat === 'system_default') ? $oReg->DefaultTimeFormat : $oReg->TimeFormat);

    $iActualTimezone = (\defined('TIMEZONE') && (TIMEZONE <> 0) ? TIMEZONE/3600 : 0);
    $iActualTimezone = ((DEFAULT_TIMEZONE <> 0) && ($iActualTimezone == DEFAULT_TIMEZONE/3600)  ? DEFAULT_TIMEZONE/3600 : $iActualTimezone);
    $sActualTimezone = (($iActualTimezone<0) ? ' %05d' : ' +%04d');

    $sLocalDebug  = (is_readable($sAddonPath.'/.setDebug'));
    $sSecureToken = (!is_readable($sAddonPath.'/.setToken'));
    $sPHP_EOL     = ($sLocalDebug ? "\n" : '');

    if (\is_readable(__DIR__.'/languages/EN.php')) {require(__DIR__.'/languages/EN.php');}
    if (\is_readable(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php')) {require(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php');}
    if (\is_readable(__DIR__.'/languages/'.LANGUAGE.'.php')) {require(__DIR__.'/languages/'.LANGUAGE.'.php');}
    if (!\function_exists('init_fields')) {require ($sAddonPath.'/functions.php');}
// declare some vars
    $iNow         = time();
    $unixtime     = $iNow;
    $filesize     = 0;
    $dlFile       = 0;
    $position     = 0;
    $checkfiles   = false;
    $settings     = [];
// declare search vars
    $searchfor    = [];
    $search_num   = [];
    $bResetSearch = [];
    $search       = [];
    $searchstart  = [];
    $dlsearch     = [];
    $searchsubmit = [];
    $searchend    = [];
    $search_id    = [];

    $searchfor[$section_id]    = '';
    $search_num[$section_id]   = 0;
    $bResetSearch[$section_id] = false;
//    $checkfiles[$section_id]   = true;

    $settings[$section_id]['group_header']  = '';
    $settings[$section_id]['group_loop']    = '';
    $settings[$section_id]['group_footer']  = '';
    $settings[$section_id]['group_order']   = '';
    $settings[$section_id]['search_filter'] = '';
    $settings[$section_id]['search_layout'] = '';
    $settings[$section_id]['header']        = '';
    $settings[$section_id]['file_header']   = '';
    $settings[$section_id]['files_loop']    = '';
    $settings[$section_id]['file_footer']   = '';
    $settings[$section_id]['footer']        = '';

    $time_start = microtime_float();
    echo "<!-- start download gallery start -->\n";
?>
    <div class="w3-row">
        <div class="w3-dlg-content w3-col l12 m12 w3-padding-bottom">
<?php

    // create shortcut for db queries
    $DG_PREFIX = TABLE_PREFIX."mod_download_gallery";
    $DG_FILES  = $DG_PREFIX.'_files';
    // Get settings
    $sQuery = 'SELECT * FROM `'.$DG_PREFIX.'_settings` '.$sPHP_EOL
            . 'WHERE `section_id` = '.(int)$section_id.'';
    $query_settings = $database->query($sQuery);
    if ($query_settings->numRows() > 0){$settings = $query_settings->fetchAssoc();}

    // replace the following settings to some more readable ones
    $files_per_page = $settings['files_per_page'];
    $settings[$section_id]['group_header']   = $settings['gheader'];
    $settings[$section_id]['group_loop']     = $settings['gloop'];
    $settings[$section_id]['group_footer']   = $settings['gfooter'];
    $settings[$section_id]['group_order']    = $settings['extordering'];

    $settings[$section_id]['search_filter']  = $settings['search_filter'];
    $settings[$section_id]['search_layout']  = $settings['search_layout'];

    $settings[$section_id]['header']         = $settings['header'];
    $settings[$section_id]['file_header']    = $settings['file_header'];
    $settings[$section_id]['files_loop']     = $settings['files_loop'];
    $settings[$section_id]['file_footer']    = $settings['file_footer'];
    $settings[$section_id]['footer']         = $settings['footer'];
#######################################################################################
// start the single output
#######################################################################################
    if (isset($aRequestVars['file']) && \is_numeric($aRequestVars['file'])) {
        $dlFile  = \intval($aRequestVars['file']);
        // Work-out if we need to add limit code to sql
        $limit_sql = ($settings['files_per_page'] != 0) ? " LIMIT 1" : "";
    }
#######################################################################################
// start the complete filelist
#######################################################################################
    else {
      // Work-out if we need to add limit code to sql
      $limit_sql = ($settings['files_per_page'] != 0) ? " LIMIT $position, {$settings['files_per_page']}" : "";
    }
/*-----------------------------------------------------------------------------------*/
        // ordering ASC | DESC
        $ordering = (($settings['ordering'] >= 16) || $settings['ordering'] == -1) ? ' DESC' : ' ASC';
        // order by first call with settings order
                switch ($settings['ordering']):
                    case 0:
                    case 16:
                        $orderby = '`title`'.$ordering;
                        break;
                    case 1:
                    case 32:
                        $orderby = '`released`'.$ordering;
                        break;
                    case 2:
                    case 64:
                        $orderby = '`modified_when`'.$ordering;
                        break;
                    case 4:
                    case 128:
                        $orderby = '`size`'.$ordering;
                        break;
                    case 8:
                    case 256:
                        $orderby = '`position`'.$ordering;
                        break;
                    default:
                        $orderby = '`released`'.$ordering;
                endswitch;
        $orderby = \sprintf('`files`.%s', $orderby);
        $sExtOrdering = (($settings[$section_id]['group_order'] >= 4) || $settings[$section_id]['group_order'] == -1) ? ' DESC' : ' ASC';
        switch ( $settings[$section_id]['group_order']):
            case '0':
            case '4':
                $sExtOrderby   = "`title`".$sExtOrdering;
                break;
            case '1':
            case '8':
                $sExtOrderby   = "`group_id`".$sExtOrdering;
                break;
            case '2':
            case '16':
            default:
                $sExtOrderby   = "`position`".$sExtOrdering;
        endswitch;
        $sExtOrderby = \sprintf('`groups`.%s ', $sExtOrderby);

        // init vars
        $adtitle = $adchanged = $adsize = $adcount = $adpos = $dlsearch[$section_id] = $searchfor[$section_id] = $sort = "";
        $checkfiles = true;
        $position   = 0;
        $search_num[$section_id] = 0;
        /*
            SORTING
            =======
            there may be up to 10 different buttons
            check which one the user pressed, if any
            (we do not need to check the search button, this is done by the searchfor field)
        */
        if ((isset($aRequestVars['NB'])) && (isset($aRequestVars['NP'])) && (\is_numeric($aRequestVars['NP'])) && ($aRequestVars['NP'] >= 0)) {
                // go to next page
                $position = \intval($aRequestVars['NP']); // start point (number of first entry to display)
                if (isset($aRequestVars['SF'])){$sort = $aRequestVars['SF'];}
        } elseif ((isset($aRequestVars['PB'])) && (isset($aRequestVars['PP'])) && (\is_numeric($aRequestVars['PP'])) && ($aRequestVars['PP'] >= 0)) {
                // go to prev page
                $position =  \intval($aRequestVars['PP']); // start point (number of first entry to display)
                if (isset($aRequestVars['SF'])){$sort = $aRequestVars['SF'];}
        }
        if (isset($aRequestVars['R1']))    {$sort = $aRequestVars['sort1'];}  // sort by title
        elseif (isset($aRequestVars['R2'])){$sort = $aRequestVars['sort2'];}  // sort by time stamp
        elseif (isset($aRequestVars['R3'])){$sort = $aRequestVars['sort3'];}  // sort by size
        elseif (isset($aRequestVars['R4'])){$sort = $aRequestVars['sort4'];}  // sort by number of downloads
        elseif (isset($aRequestVars['R5'])){$sort = $aRequestVars['sort5'];}  // sort by file position (as in backend)
        elseif (isset($aRequestVars['R6'])){$sort = $aRequestVars['sort6'];}  // sort by file time)
        elseif (isset($aRequestVars['ShowAll'])) {
            // clean search field
            $searchfor[$section_id] = '';
            $position     = 0;
            $bResetSearch[$section_id] = true;
        }elseif (empty($searchfor[$section_id])) {
            // no sort button pressed; probably first call; we check whether files have been updated
            $checkfiles = true;
        }
        // init default sorting vars
        $ctitle     = 'TA'; //
        $ctime      = 'FA'; //
        $cchanged   = 'CA'; //
        $csize      = 'SA'; //
        $ccount     = 'DA'; //
        $cpos       = 'PA'; //
        $adtitle    = ''; //
        $adchanged  = ''; //
        $adsize     = ''; //
        $adrelease  = ''; //
        $adcount    = ''; //
        $adpos      = ''; //
        if (($settings['ordering'] < 0)) {
        // check and sanitize whether sorting is active
            switch ($sort):
            //title
                case 'TA':
                    $orderby   = "title";
                    $ordering  = "ASC";
                    $adtitle   = 'asc';
                    $ctitle    = 'TD';
                    break;
                case 'TD':
                    $orderby   = "title";
                    $ordering  = "DESC";
                    $adtitle   = 'desc';
                    break;
            // entry modified
                case 'CA':
                    $orderby   = "modified_when";
                    $ordering  = "ASC";
                    $adchanged = 'asc';
                    $cchanged  = 'CD';
                    break;
                case 'CD':
                    $orderby   = "modified_when";
                    $ordering  = "DESC";
                    $adchanged = 'desc';
                    break;
            //file size
                case 'SA':
                    $orderby   = "size";
                    $ordering  = "ASC";
                    $adsize    = 'asc';
                    $csize     = 'SD';
                    break;
                case 'SD':
                    $orderby   = "size";
                    $ordering  = "DESC";
                    $adsize    = 'desc';
                    break;
            //file date
                case 'FA':
                    $orderby   = "released";
                    $ordering  = "ASC";
                    $adrelease = 'asc';
                    $ctime     = 'FD';
                    break;
                case 'FD':
                    $orderby   = "released";
                    $ordering  = "DESC";
                    $adrelease = 'desc';
                    break;
            // downloads count
                case 'DA':
                    $orderby   = "dlcount";
                    $ordering  = "ASC";
                    $adcount   = 'asc';
                    $ccount    = 'DD';
                    break;
                case 'DD':
                    $orderby   = "dlcount";
                    $ordering  = "DESC";
                    $adcount   = 'desc';
                    break;
            // position
                case 'PA':
                    $orderby   = "position";
                    $ordering  = "ASC";
                    $adpos     = 'asc';
                    $cpos      = 'PD';
                    break;
                case 'PD':
                    $orderby   = "position";
                    $ordering  = "DESC";
                    $adpos     = 'desc';
                    break;
                default:
                    $orderby   = "released";
                    $ordering  = "DESC";
                    $adpos     = 'desc';
            endswitch;
            $orderby = sprintf('`files`.`%s` %s', $orderby,$ordering);
        }
//        echo $orderby, '<br />';
        // is local search active?
        if (isset($aRequestVars['searchfor_'.$section_id])) {
            if (!isset($aRequestVars['ShowAll'])){
                $searchfor[$section_id] = \htmlspecialchars($aRequestVars['searchfor_'.$section_id], ENT_QUOTES);
            }
        }
        // Get total number of available download entries
        $sQuery = 'SELECT COUNT(*) as `total_num` FROM `'.$DG_PREFIX.'_files` '.$sPHP_EOL
                . 'WHERE `section_id` = '.(int)$section_id.' '.$sPHP_EOL
                .   'AND `active` = 1 '.$sPHP_EOL
                .   ($dlFile ? 'AND `file_id` = '.(int)$dlFile.' '.$sPHP_EOL : '')
                .   'AND `title` != \'\''.$sPHP_EOL
                . ''.$sPHP_EOL;
        $total_num = $database->get_one($sQuery);
        //Query for search results
        if ($searchfor[$section_id]!=="") {
            $dlsearch[$section_id] = ' AND ('.' `files`.`title` LIKE \'%$searchfor[$section_id]%\' OR `files`.`description` LIKE \'%$searchfor[$section_id]%\')';
            $sQuery   = 'SELECT `file_id` FROM `".$DG_FILES."` as `files` '.$sPHP_EOL
                      . 'WHERE `section_id` = '.(int)$section_id.' '
                      . ' AND `active` = 1 AND `title` != \'\' '.$sPHP_EOL
                      . $dlsearch[$section_id].$sPHP_EOL;
            $query_filter_num = $database->query($sQuery);
            $search_num[$section_id] = $query_filter_num->numRows();

        }
        // build current link, should be secure against xss:
        if (($oRequest->issetServerVar('HTTPS')) && ($oRequest->getServerVar('HTTPS')=="on")) {
            $selflink = "https://";
        } else {
            $selflink = "http://";
        }
        $selflink .= $oRequest->getServerVar('SERVER_NAME'). $oRequest->getServerVar('SCRIPT_NAME');
        $selflink = WB_URL.PAGES_DIRECTORY.$GLOBALS['wb']->page['link'].PAGE_EXTENSION;
        //replace search in heading with searchlayout replacing searchbox submit and reset
        // TODO replave all POSTs with filter
        if ($settings[$section_id]['search_filter'] === '1') {
            //create the search form
            $searchstart[$section_id]='<div class="dlsearch">';
/*
            $searchbox= "<input type='text' name='searchfor' value='$searchfor[$section_id]' />\n";
            $searchsubmit = '<input type="submit" value="'.$DGTEXT['SEARCHinLIST']."\" />\n";
*/
            $searchbox[$section_id] = '
              <div class="w3-third">
                  <input class="searchfor w3-border" type="text" placeholder="'.$DGTEXT['SEARCHLAYOUT'].'.." name="searchfor_'.$section_id.'" value="'.$searchfor[$section_id].'"/>
              </div>
      ';
            $searchsubmit[$section_id] = '
                  <button type="submit"><i class="fa fa-search">&nbsp;</i></button>
            ';

            if ($searchfor[$section_id] != '') {
                $searchsubmit[$section_id] .= '
                  <input class="search-reset" type="submit" name="ShowAll" value="'.$DGTEXT['SHOW_ALL'].'" />
                '.PHP_EOL;
            }
            if ($searchfor[$section_id] === '') { //  || $bResetSearch[$section_id]
                $searchresult[$section_id] = '';
            } else {
                $searchresult[$section_id]=
                    \str_replace(
                        ['[SEARCHMATCH]','[OUT_OF1]','[OUT_OF2]', '[ITEMS]'],
                        [$DGTEXT['SEARCHMATCH'], $DGTEXT['OUT_OF1'], $DGTEXT['OUT_OF2'], $DGTEXT['ITEMS']],
                        //[$DGTEXT['SEARCHMATCH'], $DGTEXT['OUT_OF1'], $DGTEXT['OUT_OF2'], $DGTEXT['ITEMS']],
                        \sprintf('<div class="search-fill"><!-- fill --></div><div class="search-result">[SEARCHMATCH] <b>%d</b> [OUT_OF1] <b>%s</b> [OUT_OF2] <b>%d</b> [ITEMS]</div>',$search_num[$section_id],$searchfor[$section_id],$total_num)
                    );

            }
            $searchend[$section_id] = '
            </div> <!-- search end  -->
            ';
            $search[$section_id]  = $searchstart[$section_id];
            $search[$section_id] .=
                \str_replace(
                    ['[SEARCHBOX]','[SEARCHSUBMIT]','[SEARCHRESULT]'],
                    [$searchbox[$section_id], $searchsubmit[$section_id], $searchresult[$section_id]],
                    $settings[$section_id]['search_layout']
                );

            $search[$section_id] .= $searchend[$section_id];
        } else {
            $search[$section_id] = \str_replace(
                    ['[SEARCHBOX]','[SEARCHSUBMIT]','[SEARCHRESULT]'],
                    ['', '', ''],
                    $settings[$section_id]['search_layout']
                );
        }
        // Create previous and next links
        if($settings['files_per_page'] !== 0) {
            $prevnext = true;
            if ($search_num[$section_id] === 0){
                $view_num = $total_num;
            } else{
                $view_num = $search_num[$section_id];
            }
            $pn_button_pattern  = '<input type="hidden" name="NP" value="%d" />'.PHP_EOL
                                . '<button class="mod_download_gallery_btn_f" type="submit" name="%s">%s</button>'.PHP_EOL;
             // I am not sure whether someone will need NEXT entry and PREVIOUS entry at all, but it was already here:
            $previous_link      = ($position > 0) ? \sprintf($pn_button_pattern,'PP',($position-1),'PB', "&lt;&lt; ".$TEXT['PREVIOUS']) :'';
            $previous_page_link = ($position > 0) ? \sprintf($pn_button_pattern,'PP',($position-$settings['files_per_page']),'PB', "&lt;&lt; ".$TEXT['PREVIOUS_PAGE']):'';
            $next_link          = ($position+$settings['files_per_page'] >= $view_num) ? '' : \sprintf($pn_button_pattern,'NP',($position+1),'NB', $TEXT['NEXT']." &gt;&gt;");
            $next_page_link     = ($position+$settings['files_per_page'] >= $view_num) ? '' : \sprintf($pn_button_pattern,'NP',($position+$settings['files_per_page']),'NB', $TEXT['NEXT_PAGE']." &gt;&gt;");
            // check whether less entries available than allowed
            $num_of = ($position+$settings['files_per_page'] > $view_num) ? $view_num : $position+$settings['files_per_page'];
            $of =     ($position+1).'-'.$num_of.' '.\strtolower($TEXT['OF']).' '.$view_num;
            $out_of = ($position+1).'-'.$num_of.' '.\strtolower($TEXT['OUT_OF']).' '.$view_num;
        } else {
            $prevnext = false;
        }
        // Print header
            $search_id[$section_id]  = encodeVar($section_id);
?>
            <div class="w3-row w3-container">
                <form class="dlg-search" id="dlg-search_<?php echo $section_id;?>" method="post" action="<?php echo $selflink;?>">
<?php
        $header_footer_placeholders = [
                '[DISPLAY_PREVIOUS_NEXT_LINKS]'        => (($prevnext == false) ? 'none' : 'block'),
                                '[NEXT_PAGE_LINK]'     => (($prevnext == false) ? '' : $next_page_link),
                                '[NEXT_LINK]'          => (($prevnext == false) ? '' : $next_link),
                                '[PREVIOUS_PAGE_LINK]' => (($prevnext == false) ? '' : $previous_page_link),
                                '[PREVIOUS_LINK]'      => (($prevnext == false) ? '' : $previous_link),
                                '[OUT_OF]'             => (($prevnext == false) ? '' : $out_of),
                                '[OF]'                 => (($prevnext == false) ? '' : $of),
                                '[SEARCH]'             => $search[$section_id],
        ];
/* */
        echo \str_replace(
                \array_keys($header_footer_placeholders),
                \array_values($header_footer_placeholders),
                $settings[$section_id]['header']
        );

?>
                </form>
            </div>
    <div class="dlg-search-container w3-row w3-responsive">
      <form id="dlg_<?php echo $section_id;?>" method="post" action="<?php echo $selflink;?>" autocomplete="off">
<?php
        //Display message if there is no search result
        // if (isset($aRequestVars['searchfor'])and $num_files==0) echo "<br />". $DGTEXT['NOMATCH'] . ": $searchfor"."<br />";
        // Loop through and show downloads
        $pregroup = '';
        // Query files (for this page)
        $sFileSql = "
            SELECT `files`.`title` AS 'file_title', `files`.*,`groups`.`group_id`
            FROM `".$DG_PREFIX."_files` as `files`
            LEFT JOIN `".$DG_PREFIX."_groups` AS `groups` USING(`group_id`)
            WHERE  `files`.`section_id` = '$section_id'
            AND  `files`.`active` = '1'
            ".$dlsearch[$section_id]."
            ORDER BY $sExtOrderby, $orderby " . $limit_sql.PHP_EOL;
        if (($query_files = $database->query($sFileSql))) {
        }
        $num_files = $query_files->numRows();

        if (($num_files > 0)) {
            $counter = 0;
            // SORT BUTTONS
//
            if ($settings['ordering'] >= 0 ) {
                $input_button_pattern =
                          ''
                        . '<input class="icon" type="hidden" name="sort%1$d" value="%2$s" />'.PHP_EOL
                        . '<span class="mod_download_gallery_btn_ra_f mod_download_gallery_%3$s_f" data-sort="R%4$d" data-ey="_%5$s">%6$s&nbsp;</span>'.PHP_EOL;
                $button_placeholders = array(
                        '[THTITLE]'    => \sprintf($input_button_pattern, 0, $ctitle,$adtitle, 0, $DGTEXT['THTITLE'], $DGTEXT['THTITLE']),
                        '[THRELEASED]' => \sprintf($input_button_pattern, 0, $ctime,$adrelease, 0, $DGTEXT['THRELEASED'],$DGTEXT['THRELEASED']),
                        '[THCHANGED]'  => \sprintf($input_button_pattern, 0, $cchanged, $adchanged, 0, $DGTEXT['THCHANGED'], $DGTEXT['THCHANGED']),
                        '[THSIZE]'     => \sprintf($input_button_pattern, 0, $csize,$adsize, 0, $DGTEXT['THSIZE'],$DGTEXT['THSIZE']),
                        '[THCOUNT]'    => \sprintf($input_button_pattern, 0, $ccount,$adcount, 0, $DGTEXT['THCOUNT'],$DGTEXT['THCOUNT']),
                        '[THPOSITION]' => \sprintf($input_button_pattern, 0, $cpos,$adpos, 0, 'Pos','Pos')
                );
            }else {
                $input_button_pattern =
                          ''
                        . '<input class="icon" type="hidden" name="sort%1$d" value="%2$s" />'.PHP_EOL
                        . '<button class="mod_download_gallery_btn_ra_f mod_download_gallery_%3$s_f" type="submit" name="R%4$d" value="%5$s">%6$s</button>'.PHP_EOL;
                $button_placeholders = array(
                        '[THTITLE]'    => \sprintf($input_button_pattern, 1, $ctitle,$adtitle, 1, $DGTEXT['THTITLE'], $DGTEXT['THTITLE']),
                        '[THRELEASED]' => \sprintf($input_button_pattern, 6, $ctime,$adrelease, 6, $DGTEXT['THRELEASED'],$DGTEXT['THRELEASED']),
                        '[THCHANGED]'  => \sprintf($input_button_pattern, 2, $cchanged, $adchanged, 2, $DGTEXT['THCHANGED'], $DGTEXT['THCHANGED']),
                        '[THSIZE]'     => \sprintf($input_button_pattern, 3, $csize,$adsize, 3, $DGTEXT['THSIZE'],$DGTEXT['THSIZE']),
                        '[THCOUNT]'    => \sprintf($input_button_pattern, 4, $ccount,$adcount, 4, $DGTEXT['THCOUNT'],$DGTEXT['THCOUNT']),
                        '[THPOSITION]' => \sprintf($input_button_pattern, 5, $cpos,$adpos, 5, 'Pos','Pos')
                );
            }
            // REPLACE BUTTON PLACEHOLDERS WITH VALUES
            $sDlgNavbar =  \str_replace(
                    \array_keys($button_placeholders),
                    \array_values($button_placeholders),
                    $settings[$section_id]['file_header']
                );
            if ($sort != ""){
                $settings[$section_id]['file_header'] .= "<input type='hidden' name='SF' value='$sort' />".PHP_EOL;
            }
            echo $sDlgNavbar;
            //--> start FILE LOOP
            while ($file = $query_files->fetchAssoc()) {
                //$setting_group
                if ($file['group_id'] !== $pregroup){

                    $sSqlGroups = \sprintf("SELECT `group_id`, `title`, `description`, `active` FROM `%s` WHERE section_id = '%d' AND group_id='%d' AND active ='1'",$DG_PREFIX."_groups",$section_id, $file['group_id'] );
                    $query_groups = $database->query($sSqlGroups);
                    if (($groups = $query_groups->fetchAssoc())){
                        $group_title = ($groups['title'] != "") ? $groups['title'] : $DGTEXT['NOGROUP'] ;
                        if (!empty($group_title)) {
                             $group_header = $settings[$section_id]['group_header'];
                             $group_loop = \str_replace(
                                  ['[GROUPTITLE]','[GROUP_INFO]','[GROUP_EMPTY]'],
                                  [$group_title,$groups['description'],
                                  (empty($groups['description']) ? 'w3-hide' : 'w3-show')
                                  ],
                                  $settings[$section_id]['group_loop']
                             );
                             $group_footer = $settings[$section_id]['group_footer'];
                             echo $group_header.($group_loop).$group_footer;
                        }
                    }
                }
                $groups['active'] = ($groups['active'] ?? '0');
                if (($groups['active'] !== '1')){continue;}

                if ($checkfiles === true) {
                    // Workout date and time of last modified file
                    $file_date = "";
                    $file_time = "";
                    $filesize = 0;
                    $unixtime = $iNow;
                    $uri = $file['filename'];

                    if (\strpos($uri, ':/') > 1) {
                        // remote file with uri:
                        //echo "<!-- DEBUG: remote file with uri -->\n";
                        $treffer = 0;
                        $fp = \fopen( $uri, "rb" );
                        if ($fp ) {
                            //echo "<!-- DEBUG: fopen success -->\n";
                            $MetaData = \stream_get_meta_data( $fp );
                            //print_r ($MetaData);

                            foreach( $MetaData['wrapper_data'] as $response ) {
                                //echo "<!-- DEBUG response: $response -->\n";
                                // case: redirection

                                if (\substr(\strtolower($response), 0, 10 ) == 'location: ' ) {
                                        $newUri = \substr( $response, 10 );
                                        \fclose( $fp );
                                        break;
                                }
                                // case: last-modified
                                elseif (\substr(\strtolower($response), 0, 15 ) == 'last-modified: ' ) {
                                        $unixtime = \strtotime(\substr($response, 15) );
                                        $treffer ++;
                                        if ($treffer > 1) break;
                                }
                                // case: Content-Length:
                                elseif (\substr(\strtolower($response), 0, 16 ) == 'content-length: ' ) {
                                        $filesize = \substr($response, 16);
                                        $treffer ++;
                                        if ($treffer > 1) break;
                                }
                            }// end foreach metatags
                            \fclose( $fp );
/*
print '<pre  class="mod-pre w3-hide" style="margin-left:30px;">function <span>'.__FUNCTION__.'( '.''.' );</span>  filename: <span>'.basename(__FILE__).'</span>  line: '.__LINE__.' -> '."\n";
print_r( ['$uri'=> $uri,'$unixtime'=> $unixtime,'$filesize'=> $filesize,] ); print '</pre>'; \flush (); //  sleep(10); die();
*/
                        }
                        //else echo "<!-- DEBUG could not open uri $uri -->\n";
                    } else {
                        $filelink = (strpos($file['link'], '\\')===0) ? $file['link'] : \str_replace(WB_URL,'',$file['link']);
//echo \nl2br(\sprintf("---- [%04d] time() %s \n",__LINE__,$unixtime));
                        if (\is_readable(WB_PATH.MEDIA_DIRECTORY.$filelink)) {
                            $unixtime = \filemtime(WB_PATH.MEDIA_DIRECTORY.$filelink);
//echo \nl2br(\sprintf("---- [%04d] mtime %s %s \n",__LINE__,$file['filename'],$unixtime));
                            $filesize = \filesize(WB_PATH.MEDIA_DIRECTORY.$filelink);
//echo \nl2br(\sprintf("---- [%04d] size %s %s \n",__LINE__,$file['filename'],$filesize));
                        }
                    }

                    // update file size in DB if necessary:
                    if (($file['size'] !== $filesize) && ($filesize > 0)) {
                        //echo "<!-- DEBUG file size probably changed -->\n";
                        $file_id = $file['file_id'];
                        $sSqlFiles = 'UPDATE `'.$DG_PREFIX.'_files`'
                                   . 'SET'
                                   . '`size` ='.(int)$filesize.' '
                                   . 'WHERE `file_id` ='.(int)$file_id;
                        $database->query($sSqlFiles);
                    }
                    // update file date in DB if necessary:
                    if (($file['released'] !== $unixtime) && ($unixtime > 0)) {
//echo \nl2br(\sprintf("---- [%04d] mtime %s %s \n",__LINE__,$file['filename'],$unixtime));
                        echo "<!-- DEBUG file size probably changed -->\n";
                        $file_id = $file['file_id'];
                        $sSqlFiles = 'UPDATE `'.$DG_PREFIX.'_files`'
                                   . 'SET'
                                   . '`released` ='.(int)$unixtime.' '
                                   . 'WHERE `file_id` ='.(int)$file_id;
                        $database->query($sSqlFiles);
                    }
                    $size = human_file_size($filesize,(int)($settings['file_size_roundup'] ? 0 : $settings['file_size_decimals']));
                    $file_date = PreCheck::getStrftime($sDateFormat, $file['modified_when']+TIMEZONE);
                    $file_time = \date($sTimeFormat, $file['modified_when']+TIMEZONE);
                    $release_date= PreCheck::getStrftime($sDateFormat, $unixtime+TIMEZONE);
                    $release_time= PreCheck::getStrftime($sTimeFormat, $unixtime+TIMEZONE);
//print '<pre  class="mod-pre w3-hide" style="margin-left:30px;">function <span>'.__FUNCTION__.'( '.''.' );</span>  filename: <span>'.basename(__FILE__).'</span>  line: '.__LINE__.' -> '."\n";
//print_r( [$file['filename'],$sDateFormat,$release_date,$release_time,$unixtime,$size] ); print '</pre>'; \flush (); //  sleep(10); die();
                }
                elseif ($checkfiles == false)
                {
                    echo "<!-- DEBUG checkfiles == false -->\n";
                    $size = human_file_size($file['size'],(int)($settings['file_size_roundup'] ? 0 : $settings['file_size_decimals']));
                    $file_date = \strftime($sDateFormat, $file['modified_when']+TIMEZONE);
                    $file_time = \date($sTimeFormat, $file['modified_when']+TIMEZONE);
                    $release_date= \strftime($sDateFormat, $file['released']+TIMEZONE);
                    $release_time= \date($sTimeFormat, $file['released']+TIMEZONE);
//print '<pre  class="mod-pre w3-hide" style="margin-left:30px;">function <span>'.__FUNCTION__.'( '.''.' );</span>  filename: <span>'.basename(__FILE__).'</span>  line: '.__LINE__.' -> '."\n";
//print_r( [$file['filename'],$sDateFormat,$release_date,$release_time,$unixtime,$size] ); print '</pre>'; \flush (); //  sleep(10); die();
                }
                // workout Extension ICON => [FTIMAGE]
                $unknown_icon = $sAddonUrl.'/images/unknown.gif';
                $sqlExt = \sprintf("SELECT `file_image` FROM `%s` WHERE FIND_IN_SET( '%s', `extensions` ) > 0 ",$DG_PREFIX."_file_ext", $file['extension']);
                if ($ext_icon = $database->get_one($sqlExt)){
                    $ext_icon = \str_replace('unknown.gif', $ext_icon, $unknown_icon);
                }else{
                    $ext_icon = $unknown_icon;
                }
                $dldescription = $file['description'];
                $descriptionInfo = $DGTEXT['SHOW_DESCR'];
                // Get user data
                $users = [];
                $query_users = $database->query("SELECT `user_id`, `username`, `display_name`, `email` FROM ".TABLE_PREFIX."users");
                if ($query_users->numRows() > 0) {
                    while ($user = $query_users->fetchRow(MYSQLI_ASSOC)) {
                        // Insert user info into users array
                        $user_id = $user['user_id'];
                        $users[$user_id]['username']    = $user['username'];
                        $users[$user_id]['display_name']= $user['display_name'];
                        $users[$user_id]['email']       = $user['email'];
                    }
                }
                $uid = $file['modified_by'];
                $uid = (isset($users[$uid]) ? $uid : '1');
                // Work-out the file link
                $file_placeholders = array(
                      '[TITLE]'        => $file['title'],
                      '[DESCRIPTION]'  => $dldescription,
                      '[DESCR_EMPTY]'  => (empty($dldescription) ? 'w3-hide' : 'w3-block'),
                      '[DESCR_TOGGLE]' => \sprintf($descriptionInfo,$file['title']),
                      '[LINK]'         => $sAddonUrl . '/dlc.php?id='.encodeVar($file['file_id']), // file=' .$file['file_id'].'&amp;id='.$file['modified_when']
                      '[EXT]'          => $file['extension'],
                      '[POS]'          => $file['position'],
                      '[SIZE]'         => $size,
                      '[FTIMAGE]'      => $ext_icon,
                      '[DATE]'         => $file_date, //modified_when
                      '[TIME]'         => $file_time, // modified_when
                      '[RELEASED]'     => $release_date,
                      '[RELTIME]'      => $release_time,
                      '[RELTIMEZONE]'  => \sprintf($sActualTimezone,$iActualTimezone),
                      '[DL]'           => ($file['dlcount']=="") ? 0 : $file['dlcount'],
                      '[FID]'          => $file['file_id'],
                      '[USER_ID]'      => $file['modified_by'],
                      '[USERNAME]'     => $users[$uid]['username'],
                      '[DISPLAY_NAME]' => $users[$uid]['display_name'],
                      '[EMAIL]'        => $users[$uid]['email'],
                );

                // REPLACE FILE PLACEHOLDERS WITH VALUES
                $files_loop = \str_replace(
                          \array_keys($file_placeholders),
                          \array_values($file_placeholders),
                          $settings[$section_id]['files_loop']
                );
//                $files_loop = preg_replace('/[\[\@]+/mi','[',$files_loop);
                echo $files_loop;
                $pregroup = $file['group_id'];
                $counter ++; // Increment counter
            }
            //<-- end FILE LOOP
            echo $settings[$section_id]['file_footer'];
        }
        // Print footer
/* */
$header_footer_placeholders = [
                '[DISPLAY_PREVIOUS_NEXT_LINKS]' =>( ($prevnext == false) ? 'none' : 'none')];
        $sFooter = \str_replace(
                  \array_keys($header_footer_placeholders),
                  \array_values($header_footer_placeholders),
                  $settings[$section_id]['footer']
              );
        echo $sFooter."\n";

?>
      </form>
    </div>
<?php
        //display upload link if setting is set to allow this
        if ($settings['userupload'] ==1 ||
            (
              $settings['userupload']==2 &&
              isset($_SESSION['USER_ID']) &&
              $_SESSION['USER_ID'] != "" &&
              \is_numeric($_SESSION['USER_ID'])
            )
        ){
            echo '<a href="'.$sAddonUrl.'/dluser_add.php?sid='.$section_id.'&amp;pid='.$page_id.'">'.$DGTEXT['UPLOADFILE']. '</a>';
        }
        $time_end = microtime_float();
        $runtime = \round($time_end - $time_start, 4);
        #echo "<-- gallery generated in ".$runtime." seconds -->\n";
?>
        </div>
    </div>
<?php
        echo "\n<!-- end download gallery -->\n";
?>
<script>
    const box  = document.querySelectorAll('label[id*="TOGGLE_"]');
    const desc = document.querySelectorAll('div[id*="DESCR_"]');
    if (box){
        for (let i = 0; i < box.length; i++) {
            box[i].addEventListener("click", function() {
                box[i].classList.toggle("fa-minus");
                desc[i].classList.toggle("w3-show");
//console.log( desc[i].classList );
            },
            false
            );
        }
    } // tips
    
</script>
